<?php
/**
 * u2uadmin Hack for XMB
 * Reference codebase 1.9.11.15.
 *
 * Developed And Maintained By The XMB Group
 * Copyright (c) 2001-2017, The XMB Group
 * https://www.xmbforum2.com/
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <https://www.gnu.org/licenses/>.
 *
 **/

define('X_SCRIPT', 'u2uadmin.php');

// Get required files
require 'header.php';

header('X-Robots-Tag: noindex');

// Reset all variables
$action = postedVar('action', '', FALSE, FALSE, FALSE, 'g');
$folder = postedVar('folder', '', true, true, true, 'r');
$leftpane = '';
$msg = '';
$thewidth = ($self['useoldu2u'] == 'yes') ? $THEME['tablewidth'] : '100%';
$u2u = '';
$u2u_select = postedArray( 'u2u_select', 'int', null, false, false );
$u2udateline = '';
$u2ufolder = '';
$u2ufrom = '';
$u2uid = getInt('u2uid', 'r');
$u2ulist = '';
$u2umessage = '';
$u2ureadstatus = '';
$u2usdraft = '';
$u2usent = '';
$u2usin = '';
$u2usout = '';
$u2usubject = '';
$u2uto = '';
$uid = postedVar('uid', null, true, true, false, 'g');
$uidtitle = postedVar('uid', null, true, false, false, 'g');
$uidurl = recodeOut( $uidtitle );

// Load templates
loadtemplates(
'error_nologinsession',
'u2u_admin',
'u2u_drafts',
'u2u_footer',
'u2u_header_admin',
'u2u_inbox',
'u2u_main_admin',
'u2u_outbox',
'u2u_row_admin',
'u2u_row_none',
'u2u_view_admin',
'u2u_msg'
);

smcwcache();

// Eval necessary templates
eval('$css       = "'.template('css').'";');
eval('$u2uheader = "'.template('u2u_header_admin').'";');
eval('$u2ufooter = "'.template('u2u_footer').'";');

// Check to see whether the user trying to access the page has admin status.
// If there is no administration status the user will be displayed with a login box.
if (!X_SADMIN) {
    eval('$notadmin = "'.template('error_nologinsession').'";');
    echo $u2uheader, $notadmin, $u2ufooter;
    exit;
}

$auditaction = addslashes("$onlineip|#|u2uadmin?uid=$uid");
audit($xmbuser, $auditaction, 0, 0);

// Check to see if member exists
$userid = $db->fetch_array($db->query("SELECT uid FROM ".X_PREFIX."members WHERE username='$uid'"));
if (empty($userid['uid'])) {
    error($lang['nomember'], false, $u2uheader, $u2ufooter, false, true, false, false);
}

// Start actions
switch($action) {
    case "view":
        $query = $db->query("SELECT * FROM ".X_PREFIX."u2u WHERE u2uid='$u2uid' AND owner='$uid'");
        if ( $u2u = $db->fetch_array($query)) {
            $u2udate = gmdate($dateformat, $u2u['dateline'] + ($timeoffset * 3600) + ($addtime * 3600));
            $u2utime = gmdate($timecode, $u2u['dateline'] + ($timeoffset * 3600) + ($addtime * 3600));
            $u2udateline = "$u2udate {$lang['textat']} $u2utime";
            $u2usubject = rawHTMLsubject(stripslashes($u2u['subject'])); //message and subject were historically double-slashed
            $u2umessage = postify(stripslashes($u2u['message']), 'no', '', 'yes', 'no');
            $u2ufolder = $u2u['folder'];
            $u2ufrom = "<a href=\"member.php?action=viewpro&amp;member=".$u2u['msgfrom']."\" target=\"mainwindow\">".recodeOut($u2u['msgfrom'])."</a>";
            $u2uto = ($u2u['type'] == 'draft') ? $lang['textu2unotsent'] : "<a href=\"member.php?action=viewpro&amp;member=".recodeOut($u2u['msgto'])."\" target=\"mainwindow\">".$u2u['msgto']."</a>";
        } else {
            error($lang['u2uadmin_noperm'], false, $u2uheader, $u2ufooter, false, true, false, false);
        }
        $db->free_result($query);
        eval('$leftpane = "'.template('u2u_view_admin').'";');
        break;
    case "delete":
        if ( ! empty( $u2uid ) ) {
            $db->query("DELETE FROM ".X_PREFIX."u2u WHERE u2uid=$u2uid AND owner='$uid'");
            u2u_msg($lang['imdeletedmsg'], "u2uadmin.php?uid=$uidurl&folder=".recodeOut($folder));
            break;
        } elseif ( is_array( $u2u_select ) && count( $u2u_select ) > 0 ) {
            $in = implode( ',', $u2u_select );
            $db->query("DELETE FROM ".X_PREFIX."u2u WHERE u2uid IN($in) AND owner='$uid'");
            u2u_msg($lang['imdeletedmsg'], "u2uadmin.php?uid=$uidurl&folder=".recodeOut($folder));
        } else {
            error($lang['textnonechosen'], false, $u2uheader, $u2ufooter, "u2uadmin.php?uid=$uidurl&folder=".recodeOut($folder), true, false, false);
        }
        break;
    default:
        if ( "Outbox" !== $folder && "Drafts" !== $folder ) {
            $folder = "Inbox";
        }
        $query = $db->query("SELECT * FROM ".X_PREFIX."u2u WHERE folder='$folder' AND owner='$uid' ORDER BY dateline DESC");
        while($u2u = $db->fetch_array($query)) {
            if ( $u2u['readstatus'] == 'yes') {
                $u2ureadstatus = $lang['textread'];
            } else {
                $u2ureadstatus = "<b>".$lang['textunread']."</b>";
            }
            if (empty($u2u['subject'])) {
                $u2u['subject'] = "&laquo;".$lang['textnosub']."&raquo;";
            }
            $u2usubject = rawHTMLsubject(stripslashes($u2u['subject'])); //message and subject were historically double-slashed
            if ( $u2u['type'] == 'incoming') {
                $u2usent = "<a href=\"member.php?action=viewpro&amp;member=".recodeOut($u2u['msgfrom'])."\" target=\"mainwindow\">".$u2u['msgfrom']."</a>";
            } elseif ( $u2u['type'] == 'outgoing') {
                $u2usent = "<a href=\"member.php?action=viewpro&amp;member=".recodeOut($u2u['msgto'])."\" target=\"mainwindow\">".$u2u['msgto']."</a>";
            } elseif ( $u2u['type'] == 'draft') {
                $u2usent = $lang['textu2unotsent'];
            }
            $u2udate = gmdate($dateformat, $u2u['dateline'] + ($timeoffset * 3600) + ($addtime * 3600));
            $u2utime = gmdate($timecode, $u2u['dateline'] + ($timeoffset * 3600) + ($addtime * 3600));
            $u2udateline = "$u2udate {$lang['textat']} $u2utime";

            switch( $u2u['type'] ) {
                case 'outgoing':
                    eval('$u2usout .= "'.template('u2u_row_admin').'";');
                    break;
                case 'draft':
                    eval('$u2usdraft .= "'.template('u2u_row_admin').'";');
                    break;
                default:
                    eval('$u2usin .= "'.template('u2u_row_admin').'";');
                    break;
            }
        }
        $db->free_result($query);
        if (empty($u2usin)) {
            eval('$u2usin = "'.template('u2u_row_none').'";');
        }
        if (empty($u2usout)) {
            eval('$u2usout = "'.template('u2u_row_none').'";');
        }
        if (empty($u2usdraft)) {
            eval('$u2usdraft = "'.template('u2u_row_none').'";');
        }
        if ( $folder == 'Outbox') {
            eval('$u2ulist = "'.template('u2u_outbox').'";');
        } elseif ( $folder == 'Drafts') {
            eval('$u2ulist = "'.template('u2u_drafts').'";');
        } else {
            eval('$u2ulist = "'.template('u2u_inbox').'";');
        }
        eval('$leftpane = "'.template('u2u_main_admin').'";');
        break;
}

// Display page
eval('echo "'.template('u2u_admin').'";');

// Function for informative messages
function u2u_msg($msg, $redirect) {
    global $u2uheader, $u2ufooter, $tablewidth, $bordercolor, $tablespace, $borderwidth, $altbg1;
    if (!empty($redirect)) {
        redirect($redirect, 0);
    }
    eval('echo "'.template('u2u_msg').'";');
    exit;
}
?>